<?php
namespace Planejamento\Logic\Cardapio;

use Geral\Util\Ambiente;
use Planejamento\Logic\Cardapio\Exception\Cardapio as CardapioException;

/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 07/02/13
 * Time: 10:08
 */
class ComposicaoPrato
{

    private $nrorg;
    private $cdfilial;
    private $nrcardapio;
    private $nrseqpratcar;

    private $compcard;

    public function __construct($nrorg, $cdfilial, $nrcardapio = null, $nrseqpratcar = null) {
        $this->nrorg = $nrorg;
        $this->cdfilial = $cdfilial;
        $this->nrcardapio = $nrcardapio;
        $this->nrseqpratcar = $nrseqpratcar;
    }



    public function deletaPrato() {
        $manager = \Setforms2\Shared\Registry::getEntityManager();

        $prato = $this->getComposicaoCardapio();
        $prato->delete();

        $manager->flush();
    }

    /**
     * @return \Planejamento\Entities\Compcard
     */
    public function getComposicaoCardapio() {
        /** @var $compcard \Planejamento\Entities\Compcard */
        $compcard = \Planejamento\Entities\Compcard::getObject(
            array(
                'nrorg'        => $this->nrorg,
                'cdfilial'     => $this->cdfilial,
                'nrcardapio'   => $this->nrcardapio,
                'nrseqpratcar' => $this->nrseqpratcar
            )
        );
        return $compcard;
    }

    public function alteraComposicaoDoCardapio(
        $vrpeconscard, $nrordpratcar, $cdfilauxprat, $cdprato, $cdtipoprat
    ) {
        /** @var $compcard \Planejamento\Entities\Compcard */
        $compcard = $this->getComposicaoCardapio();
        if (!$compcard) {
            if (tk_get_context_vars('INCLUIR', 'PERMISSOESOPER') == false) {
                tk_abort(tk_get_message_by_name('msg_pla00101_OperSemPermissao'));
            }
            
            $this->inserePratoNoCardapio($nrordpratcar, $cdfilauxprat, $cdprato, $vrpeconscard, $cdtipoprat);
        } else {
            if (tk_get_context_vars('ALTERAR', 'PERMISSOESOPER') == false) {
                tk_abort(tk_get_message_by_name('msg_pla00101_OperSemPermissao'));
            }
            
            $this->atualizaPratoNoCardapio($compcard, $cdfilauxprat, $cdprato, $vrpeconscard);
        }
    }

    public function inserePratoNoCardapio(
        $nrordpratcar, $cdfilauxprat, $cdprato, $vrpeconscard, $cdtipoprat, $nrseqpratcar = null, $idpratoespe = 'N'
    ) {

        $manager = \Setforms2\Shared\Registry::getEntityManager();

        $compcard = new \Planejamento\Entities\Compcard();

        // pk global
        $compcard->setNrorg($this->nrorg);

        // Compcard e Cardadia pk
        $compcard->setCdfilial($this->cdfilial);
        $compcard->setNrcardapio($this->nrcardapio);

        // Compcard pk
        $compcard->setNrseqpratcar(($nrseqpratcar) ? : $this->nrseqpratcar);

        $compcard->setCdfilauxprat($cdfilauxprat);
        $compcard->setCdprato($cdprato);
        $compcard->setCdtipoprat($cdtipoprat);
        $compcard->setNrordpratcar($nrordpratcar);
        $compcard->setVrpeconscard(str_replace(',', '.', $vrpeconscard));
        $compcard->setIdpratoespe($idpratoespe);
        $compcard->setDtinclusao(\Geral\Util\DateUtil::getDataAtual());
        $compcard->setDtultatu(\Geral\Util\DateUtil::getDataAtual());
        $compcard->setCdoperinclusao(Ambiente::getCdOperador());

        $compcard->persist();

        $manager->flush();
    }

    public function atualizaPratoNoCardapio(
        \Planejamento\Entities\Compcard $compcard = null, $cdfilauxprat, $cdprato, $vrpeconscard,
        $idpratoespe = 'N'
    ) {
        if (!$compcard) {
            $compcard = $this->getComposicaoCardapio();
        }
        $manager = \Setforms2\Shared\Registry::getEntityManager();

        // Prato pk
        $compcard->setCdfilauxprat($cdfilauxprat);
        $compcard->setCdprato($cdprato);

        $compcard->setVrpeconscard(str_replace(',', '.', $vrpeconscard));
        $compcard->setIdpratoespe($idpratoespe);
        $compcard->setDtultatu(\Geral\Util\DateUtil::getDataAtual());

        $compcard->persist();

        $manager->flush();
    }

    public function atualizaComensaisNoPrato(\Planejamento\Entities\Compcard $compcard, $vrpeconscard)
    {
        $manager = \Setforms2\Shared\Registry::getEntityManager();

        $compcard->setVrpeconscard((float)str_replace(',', '.', $vrpeconscard));

        $compcard->persist();
        $manager->flush();
    }

}
